#
# spec file for package upx
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           upx
Version:        3.91
Release:        6.5
Summary:        The Ultimate Packer for eXecutables
License:        GPL-2.0+
Group:          Development/Tools/Other
Url:            http://upx.sourceforge.net/

Source:         http://upx.sourceforge.net/download/%{name}-%{version}-src.tar.bz2
Source1:        http://downloads.sf.net/sevenzip/lzma922.tar.bz2
BuildRequires:  gcc-c++
BuildRequires:  libucl1-devel
BuildRequires:  zlib-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Patch0:         upx-aarch64.patch
Patch1:         upx-endiantests.patch
Patch2:         lzma-x-endian.patch

%description
UPX is a free, portable, extendable, high-performance executable packer
for several different executable formats. It achieves an excellent
compression ratio and offers very fast decompression. Your executables
suffer no memory overhead or other drawbacks.

%prep
%setup -q -n %{name}-%{version}-src
%patch0 -p1
%patch1 -p1
mkdir "%_builddir/lzma-x"
pushd "%_builddir/lzma-x"
tar -xf "%{S:1}"
%patch2 -p1
popd

# BSD-4 clause licensed file, remove just in case bnc#753791
rm src/stub/src/i386-dos32.djgpp2-stubify.asm

%build
export UPX_LZMADIR="%_builddir/lzma-x"
export UPX_LZMA_VERSION=0x922
export UPX_UCLDIR=%{_prefix}
export CXX=g++
make -C src CXXFLAGS="%{optflags} -fvisibility=hidden -fvisibility-inlines-hidden"
make -C doc

%install
install -D -m 0755 src/upx.out %{buildroot}%{_bindir}/upx
install -D -m 0644 doc/upx.1 %{buildroot}%{_mandir}/man1/upx.1

%files
%defattr(-, root, root)
%doc BUGS COPYING LICENSE NEWS PROJECTS README README.SRC THANKS
%doc doc/upx.html
%doc %{_mandir}/man1/*
%{_bindir}/*

%changelog
* Sun Nov 16 2014 crrodriguez@opensuse.org
- upx-endiantests.patch and lzma-x-endian.patch Correct
  endianness tests by only considering what the compiler says
  about target system and not a hardcoded architecture list.
  (drop upx-3.03_ia64-endianity.patch)
- build with hidden visibility.
* Mon Jan 20 2014 pgajdos@suse.com
- fix build for factory
* Fri Nov 22 2013 jengelh@inai.de
- Update to new upstream release 3.91
  * Initial support for amd64-win64.pe
- Refresh upx-3.03_ia64-endianity.patch after fuzz
* Sun Mar 31 2013 schwab@suse.de
- upx-aarch64.patch: Support for AArch64
* Wed Mar 27 2013 idonmez@suse.com
- Actually enable LZMA support, this needs LZMA SDK
* Mon Mar 25 2013 idonmez@suse.com
- Update to version 3.09
  * New option --preserve-build-id for GNU ELF.
  * Allow zero-filled final page in PackUnix::canUnpack().
  * Bug fixes.
* Thu Mar  8 2012 freespacer@gmx.de
- updated to 3.08
  * optional LZMA compression
* Thu Sep  9 2010 marix@marix.org
- updated to 3.07
  * LZMA compression support
* Wed Aug 18 2010 pgajdos@suse.cz
- updated to 3.05 (see NEWS)
* Mon Oct 12 2009 prusnak@suse.cz
- updated to 3.04
* Mon Jun  8 2009 pgajdos@suse.cz
- fixed char * -- const char * problem
  * const-cast.patch
* Thu Jul 31 2008 pgajdos@suse.cz
- updated to 3.03:
  o optional LZMA compression
* Mon Jan 21 2008 pgajdos@suse.cz
- update to 3.02:
  * fix unmapping on arm-linux.elf
  * fix error checking in mmap for i386-linux.elf [triggered by -fPIE]
  * new options --no-mode, --no-owner and --no-time to disable preservation
    of mode (file permissions), file ownership and timestamps.
  * new format linux/mipsel supports ELF on [32-bit] R3000
  * fix argv[0] on PowerPC with --lzma
  * another bug fixes
* Thu Oct  4 2007 bg@suse.de
- use ia64 fix for hppa
* Mon Jul 23 2007 pgajdos@suse.cz
- updated to 3.00 (supports some new formats)
- fixed failed build on ia64
  * ia64-endianity.patch
* Thu Mar 29 2007 meissner@suse.de
- buildrequire zlib-devel
* Tue Oct 31 2006 meissner@suse.de
- build with RPM_OPT_FLAGS
* Thu Oct  5 2006 anicka@suse.cz
- update to 2.02
  * support for many new formats
  * various bugfixes
- build for all architectures (new formats supported)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Sep 28 2005 dmueller@suse.de
- add norootforbuild
* Wed Aug 11 2004 tcrhak@suse.cz
- update to 1.25
* Thu Jul 24 2003 tcrhak@suse.cz
- update to version 1.24
* Fri May 10 2002 ro@suse.de
- removed malloc hacks (does not work this way with gcc-3.1)
* Sat Apr 20 2002 ro@suse.de
- fixed changelog
* Fri Apr 19 2002 tcrhak@suse.cz
- fixed to compile with gcc 3.1
* Mon Jan 14 2002 rvasice@suse.cz
- fix URL in spec file
* Wed Jun 20 2001 rvasice@suse.cz
- fix neededforbuild section
* Fri Jun 15 2001 rvasice@suse.cz
- initial package release (version 1.20)
